import{s as Ye,n as Ze,o as et}from"../chunks/scheduler.9bc65507.js";import{S as tt,i as rt,g as l,s as a,r as m,A as st,h as o,f as t,c as n,j as $,u as i,x as E,k as v,y as c,a as s,v as d,d as f,t as u,w as p}from"../chunks/index.707bf1b6.js";import{D as _}from"../chunks/Docstring.570ddb64.js";import{H as ae,E as at}from"../chunks/EditOnGithub.922df6ba.js";function nt(He){let b,ne,re,le,P,oe,T,qe="This page lists all of Transformers general utility functions that are found in the file <code>utils.py</code>.",me,C,Ue="Most of those are only useful if you are studying the general code in the library.",ie,L,de,h,D,De,Q,je="Enum with more explicit error message for missing values.",fe,y,M,Me,W,Be=`Possible values for the <code>padding</code> argument in <a href="/docs/transformers/pr_21171/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizerBase.<strong>call</strong>()</a>. Useful for tab-completion in an
IDE.`,ue,x,k,ke,X,Ae=`Possible values for the <code>return_tensors</code> argument in <a href="/docs/transformers/pr_21171/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.__call__">PreTrainedTokenizerBase.<strong>call</strong>()</a>. Useful for
tab-completion in an IDE.`,pe,z,ce,I,S,ge,V,H,$e,q,U,ve,j,B,_e,A,G,be,O,he,g,F,ze,Y,Ge="Descriptor that mimics @property but caches output in member variable.",Ie,Z,Oe="From tensorflow_datasets",Se,ee,Fe="Built-in in functools from Python 3.8.",ye,K,xe,N,R,Ve,te,Ke="Module class that surfaces all objects but only performs associated imports when the objects are requested.",Ne,J,Ee,se,we;return P=new ae({props:{title:"General Utilities",local:"general-utilities",headingTag:"h1"}}),L=new ae({props:{title:"Enums and namedtuples",local:"transformers.utils.ExplicitEnum",headingTag:"h2"}}),D=new _({props:{name:"class transformers.utils.ExplicitEnum",anchor:"transformers.utils.ExplicitEnum",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/generic.py#L488"}}),M=new _({props:{name:"class transformers.utils.PaddingStrategy",anchor:"transformers.utils.PaddingStrategy",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/generic.py#L500"}}),k=new _({props:{name:"class transformers.TensorType",anchor:"transformers.TensorType",parameters:[{name:"value",val:""},{name:"names",val:" = None"},{name:"module",val:" = None"},{name:"qualname",val:" = None"},{name:"type",val:" = None"},{name:"start",val:" = 1"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/generic.py#L511"}}),z=new ae({props:{title:"Special Decorators",local:"transformers.add_start_docstrings",headingTag:"h2"}}),S=new _({props:{name:"transformers.add_start_docstrings",anchor:"transformers.add_start_docstrings",parameters:[{name:"*docstr",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/doc.py#L23"}}),H=new _({props:{name:"transformers.utils.add_start_docstrings_to_model_forward",anchor:"transformers.utils.add_start_docstrings_to_model_forward",parameters:[{name:"*docstr",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/doc.py#L31"}}),U=new _({props:{name:"transformers.add_end_docstrings",anchor:"transformers.add_end_docstrings",parameters:[{name:"*docstr",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/doc.py#L53"}}),B=new _({props:{name:"transformers.utils.add_code_sample_docstrings",anchor:"transformers.utils.add_code_sample_docstrings",parameters:[{name:"*docstr",val:""},{name:"processor_class",val:" = None"},{name:"checkpoint",val:" = None"},{name:"output_type",val:" = None"},{name:"config_class",val:" = None"},{name:"mask",val:" = '[MASK]'"},{name:"qa_target_start_index",val:" = 14"},{name:"qa_target_end_index",val:" = 15"},{name:"model_cls",val:" = None"},{name:"modality",val:" = None"},{name:"expected_output",val:" = None"},{name:"expected_loss",val:" = None"},{name:"real_checkpoint",val:" = None"},{name:"revision",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/doc.py#L1064"}}),G=new _({props:{name:"transformers.utils.replace_return_docstrings",anchor:"transformers.utils.replace_return_docstrings",parameters:[{name:"output_type",val:" = None"},{name:"config_class",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/doc.py#L1162"}}),O=new ae({props:{title:"Special Properties",local:"transformers.utils.cached_property",headingTag:"h2"}}),F=new _({props:{name:"class transformers.utils.cached_property",anchor:"transformers.utils.cached_property",parameters:[{name:"fget",val:" = None"},{name:"fset",val:" = None"},{name:"fdel",val:" = None"},{name:"doc",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/generic.py#L41"}}),K=new ae({props:{title:"Other Utilities",local:"transformers.utils._LazyModule",headingTag:"h2"}}),R=new _({props:{name:"class transformers.utils._LazyModule",anchor:"transformers.utils._LazyModule",parameters:[{name:"name",val:""},{name:"module_file",val:""},{name:"import_structure",val:""},{name:"module_spec",val:" = None"},{name:"extra_objects",val:" = None"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/utils/import_utils.py#L1466"}}),J=new at({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/en/internal/file_utils.md"}}),{c(){b=l("meta"),ne=a(),re=l("p"),le=a(),m(P.$$.fragment),oe=a(),T=l("p"),T.innerHTML=qe,me=a(),C=l("p"),C.textContent=Ue,ie=a(),m(L.$$.fragment),de=a(),h=l("div"),m(D.$$.fragment),De=a(),Q=l("p"),Q.textContent=je,fe=a(),y=l("div"),m(M.$$.fragment),Me=a(),W=l("p"),W.innerHTML=Be,ue=a(),x=l("div"),m(k.$$.fragment),ke=a(),X=l("p"),X.innerHTML=Ae,pe=a(),m(z.$$.fragment),ce=a(),I=l("div"),m(S.$$.fragment),ge=a(),V=l("div"),m(H.$$.fragment),$e=a(),q=l("div"),m(U.$$.fragment),ve=a(),j=l("div"),m(B.$$.fragment),_e=a(),A=l("div"),m(G.$$.fragment),be=a(),m(O.$$.fragment),he=a(),g=l("div"),m(F.$$.fragment),ze=a(),Y=l("p"),Y.textContent=Ge,Ie=a(),Z=l("p"),Z.textContent=Oe,Se=a(),ee=l("p"),ee.textContent=Fe,ye=a(),m(K.$$.fragment),xe=a(),N=l("div"),m(R.$$.fragment),Ve=a(),te=l("p"),te.textContent=Ke,Ne=a(),m(J.$$.fragment),Ee=a(),se=l("p"),this.h()},l(e){const r=st("svelte-u9bgzb",document.head);b=o(r,"META",{name:!0,content:!0}),r.forEach(t),ne=n(e),re=o(e,"P",{}),$(re).forEach(t),le=n(e),i(P.$$.fragment,e),oe=n(e),T=o(e,"P",{"data-svelte-h":!0}),E(T)!=="svelte-1d4d2gz"&&(T.innerHTML=qe),me=n(e),C=o(e,"P",{"data-svelte-h":!0}),E(C)!=="svelte-11r0tff"&&(C.textContent=Ue),ie=n(e),i(L.$$.fragment,e),de=n(e),h=o(e,"DIV",{class:!0});var Pe=$(h);i(D.$$.fragment,Pe),De=n(Pe),Q=o(Pe,"P",{"data-svelte-h":!0}),E(Q)!=="svelte-u4x3ci"&&(Q.textContent=je),Pe.forEach(t),fe=n(e),y=o(e,"DIV",{class:!0});var Te=$(y);i(M.$$.fragment,Te),Me=n(Te),W=o(Te,"P",{"data-svelte-h":!0}),E(W)!=="svelte-g3gf2n"&&(W.innerHTML=Be),Te.forEach(t),ue=n(e),x=o(e,"DIV",{class:!0});var Ce=$(x);i(k.$$.fragment,Ce),ke=n(Ce),X=o(Ce,"P",{"data-svelte-h":!0}),E(X)!=="svelte-6ekxwf"&&(X.innerHTML=Ae),Ce.forEach(t),pe=n(e),i(z.$$.fragment,e),ce=n(e),I=o(e,"DIV",{class:!0});var Re=$(I);i(S.$$.fragment,Re),Re.forEach(t),ge=n(e),V=o(e,"DIV",{class:!0});var Je=$(V);i(H.$$.fragment,Je),Je.forEach(t),$e=n(e),q=o(e,"DIV",{class:!0});var Qe=$(q);i(U.$$.fragment,Qe),Qe.forEach(t),ve=n(e),j=o(e,"DIV",{class:!0});var We=$(j);i(B.$$.fragment,We),We.forEach(t),_e=n(e),A=o(e,"DIV",{class:!0});var Xe=$(A);i(G.$$.fragment,Xe),Xe.forEach(t),be=n(e),i(O.$$.fragment,e),he=n(e),g=o(e,"DIV",{class:!0});var w=$(g);i(F.$$.fragment,w),ze=n(w),Y=o(w,"P",{"data-svelte-h":!0}),E(Y)!=="svelte-4cuoeh"&&(Y.textContent=Ge),Ie=n(w),Z=o(w,"P",{"data-svelte-h":!0}),E(Z)!=="svelte-1mfkm3t"&&(Z.textContent=Oe),Se=n(w),ee=o(w,"P",{"data-svelte-h":!0}),E(ee)!=="svelte-1x2w0p5"&&(ee.textContent=Fe),w.forEach(t),ye=n(e),i(K.$$.fragment,e),xe=n(e),N=o(e,"DIV",{class:!0});var Le=$(N);i(R.$$.fragment,Le),Ve=n(Le),te=o(Le,"P",{"data-svelte-h":!0}),E(te)!=="svelte-tjmjug"&&(te.textContent=Ke),Le.forEach(t),Ne=n(e),i(J.$$.fragment,e),Ee=n(e),se=o(e,"P",{}),$(se).forEach(t),this.h()},h(){v(b,"name","hf:doc:metadata"),v(b,"content",lt),v(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){c(document.head,b),s(e,ne,r),s(e,re,r),s(e,le,r),d(P,e,r),s(e,oe,r),s(e,T,r),s(e,me,r),s(e,C,r),s(e,ie,r),d(L,e,r),s(e,de,r),s(e,h,r),d(D,h,null),c(h,De),c(h,Q),s(e,fe,r),s(e,y,r),d(M,y,null),c(y,Me),c(y,W),s(e,ue,r),s(e,x,r),d(k,x,null),c(x,ke),c(x,X),s(e,pe,r),d(z,e,r),s(e,ce,r),s(e,I,r),d(S,I,null),s(e,ge,r),s(e,V,r),d(H,V,null),s(e,$e,r),s(e,q,r),d(U,q,null),s(e,ve,r),s(e,j,r),d(B,j,null),s(e,_e,r),s(e,A,r),d(G,A,null),s(e,be,r),d(O,e,r),s(e,he,r),s(e,g,r),d(F,g,null),c(g,ze),c(g,Y),c(g,Ie),c(g,Z),c(g,Se),c(g,ee),s(e,ye,r),d(K,e,r),s(e,xe,r),s(e,N,r),d(R,N,null),c(N,Ve),c(N,te),s(e,Ne,r),d(J,e,r),s(e,Ee,r),s(e,se,r),we=!0},p:Ze,i(e){we||(f(P.$$.fragment,e),f(L.$$.fragment,e),f(D.$$.fragment,e),f(M.$$.fragment,e),f(k.$$.fragment,e),f(z.$$.fragment,e),f(S.$$.fragment,e),f(H.$$.fragment,e),f(U.$$.fragment,e),f(B.$$.fragment,e),f(G.$$.fragment,e),f(O.$$.fragment,e),f(F.$$.fragment,e),f(K.$$.fragment,e),f(R.$$.fragment,e),f(J.$$.fragment,e),we=!0)},o(e){u(P.$$.fragment,e),u(L.$$.fragment,e),u(D.$$.fragment,e),u(M.$$.fragment,e),u(k.$$.fragment,e),u(z.$$.fragment,e),u(S.$$.fragment,e),u(H.$$.fragment,e),u(U.$$.fragment,e),u(B.$$.fragment,e),u(G.$$.fragment,e),u(O.$$.fragment,e),u(F.$$.fragment,e),u(K.$$.fragment,e),u(R.$$.fragment,e),u(J.$$.fragment,e),we=!1},d(e){e&&(t(ne),t(re),t(le),t(oe),t(T),t(me),t(C),t(ie),t(de),t(h),t(fe),t(y),t(ue),t(x),t(pe),t(ce),t(I),t(ge),t(V),t($e),t(q),t(ve),t(j),t(_e),t(A),t(be),t(he),t(g),t(ye),t(xe),t(N),t(Ne),t(Ee),t(se)),t(b),p(P,e),p(L,e),p(D),p(M),p(k),p(z,e),p(S),p(H),p(U),p(B),p(G),p(O,e),p(F),p(K,e),p(R),p(J,e)}}}const lt='{"title":"General Utilities","local":"general-utilities","sections":[{"title":"Enums and namedtuples","local":"transformers.utils.ExplicitEnum","sections":[],"depth":2},{"title":"Special Decorators","local":"transformers.add_start_docstrings","sections":[],"depth":2},{"title":"Special Properties","local":"transformers.utils.cached_property","sections":[],"depth":2},{"title":"Other Utilities","local":"transformers.utils._LazyModule","sections":[],"depth":2}],"depth":1}';function ot(He){return et(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends tt{constructor(b){super(),rt(this,b,ot,nt,Ye,{})}}export{ut as component};
