import{s as Qt,n as Nt,o as Rt}from"../chunks/scheduler.9bc65507.js";import{S as Bt,i as Zt,g as s,s as a,r as d,A as Gt,h as i,f as r,c as n,j as v,u as c,x as l,k as $,y as t,a as p,v as u,d as f,t as h,w as g}from"../chunks/index.707bf1b6.js";import{D as _}from"../chunks/Docstring.570ddb64.js";import{H as Ye,E as Kt}from"../chunks/EditOnGithub.922df6ba.js";function Xt(wt){let F,ye,we,Ce,S,Te,I,Ft="This page lists all the utility functions the library provides for pipelines.",Le,V,yt="Most of those are only useful if you are studying the code of the models in the library.",He,W,Ee,y,q,et,ae,Ct='Base interface for handling arguments for each <a href="/docs/transformers/pr_21171/en/main_classes/pipelines#transformers.Pipeline">Pipeline</a>.',Me,C,j,tt,ne,Tt=`Handles arguments for zero-shot for text classification by turning each possible label into an NLI
premise/hypothesis pair.`,ke,P,J,rt,oe,Lt=`QuestionAnsweringPipeline requires the user to provide multiple arguments (i.e. question &amp; context) to be mapped to
internal <code>SquadExample</code>.`,at,se,Ht=`QuestionAnsweringArgumentHandler manages all the possible to create a <code>SquadExample</code> from the command-line
supplied arguments.`,Ae,U,Oe,m,z,nt,ie,Et=`Base class for all the pipeline supported data format both for reading and writing. Supported data formats
currently includes:`,ot,pe,Mt="<li>JSON</li> <li>CSV</li> <li>stdin/stdout (pipe)</li>",st,le,kt=`<code>PipelineDataFormat</code> also includes some utilities to work with multi-columns like mapping from datasets columns to
pipelines keyword arguments through the <code>dataset_kwarg_1=dataset_column_1</code> format.`,it,L,Q,pt,me,At='Creates an instance of the right subclass of <a href="/docs/transformers/pr_21171/en/internal/pipelines_utils#transformers.PipelineDataFormat">PipelineDataFormat</a> depending on <code>format</code>.',lt,H,N,mt,de,Ot='Save the provided data object with the representation for the current <a href="/docs/transformers/pr_21171/en/internal/pipelines_utils#transformers.PipelineDataFormat">PipelineDataFormat</a>.',dt,E,R,ct,ce,St="Save the provided data object as a pickle-formatted binary data on the disk.",Se,D,B,ut,ue,It="Support for pipelines using CSV data format.",ft,M,Z,ht,fe,Vt='Save the provided data object with the representation for the current <a href="/docs/transformers/pr_21171/en/internal/pipelines_utils#transformers.PipelineDataFormat">PipelineDataFormat</a>.',Ie,w,G,gt,he,Wt="Support for pipelines using JSON file format.",vt,k,K,$t,ge,qt="Save the provided data object in a json file.",Ve,x,X,bt,ve,jt="Read data from piped input to the python process. For multi columns data, columns should separated by",_t,$e,Jt="If columns are provided, then the output will be a dictionary with {column_x: value_x}",xt,A,Y,Pt,be,Ut="Print the data.",We,ee,qe,T,te,Dt,_e,zt='Raised by a <a href="/docs/transformers/pr_21171/en/main_classes/pipelines#transformers.Pipeline">Pipeline</a> when handling <strong>call</strong>.',je,re,Je,Fe,Ue;return S=new Ye({props:{title:"Utilities for pipelines",local:"utilities-for-pipelines",headingTag:"h1"}}),W=new Ye({props:{title:"Argument handling",local:"transformers.pipelines.ArgumentHandler",headingTag:"h2"}}),q=new _({props:{name:"class transformers.pipelines.ArgumentHandler",anchor:"transformers.pipelines.ArgumentHandler",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L439"}}),j=new _({props:{name:"class transformers.pipelines.ZeroShotClassificationArgumentHandler",anchor:"transformers.pipelines.ZeroShotClassificationArgumentHandler",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/zero_shot_classification.py#L14"}}),J=new _({props:{name:"class transformers.pipelines.QuestionAnsweringArgumentHandler",anchor:"transformers.pipelines.QuestionAnsweringArgumentHandler",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/question_answering.py#L150"}}),U=new Ye({props:{title:"Data format",local:"transformers.PipelineDataFormat",headingTag:"h2"}}),z=new _({props:{name:"class transformers.PipelineDataFormat",anchor:"transformers.PipelineDataFormat",parameters:[{name:"output_path",val:": Optional"},{name:"input_path",val:": Optional"},{name:"column",val:": Optional"},{name:"overwrite",val:": bool = False"}],parametersDescription:[{anchor:"transformers.PipelineDataFormat.output_path",description:"<strong>output_path</strong> (<code>str</code>) &#x2014; Where to save the outgoing data.",name:"output_path"},{anchor:"transformers.PipelineDataFormat.input_path",description:"<strong>input_path</strong> (<code>str</code>) &#x2014; Where to look for the input data.",name:"input_path"},{anchor:"transformers.PipelineDataFormat.column",description:"<strong>column</strong> (<code>str</code>) &#x2014; The column to read.",name:"column"},{anchor:"transformers.PipelineDataFormat.overwrite",description:`<strong>overwrite</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to overwrite the <code>output_path</code>.`,name:"overwrite"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L449"}}),Q=new _({props:{name:"from_str",anchor:"transformers.PipelineDataFormat.from_str",parameters:[{name:"format",val:": str"},{name:"output_path",val:": Optional"},{name:"input_path",val:": Optional"},{name:"column",val:": Optional"},{name:"overwrite",val:" = False"}],parametersDescription:[{anchor:"transformers.PipelineDataFormat.from_str.format",description:`<strong>format</strong> (<code>str</code>) &#x2014;
The format of the desired pipeline. Acceptable values are <code>&quot;json&quot;</code>, <code>&quot;csv&quot;</code> or <code>&quot;pipe&quot;</code>.`,name:"format"},{anchor:"transformers.PipelineDataFormat.from_str.output_path",description:`<strong>output_path</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Where to save the outgoing data.`,name:"output_path"},{anchor:"transformers.PipelineDataFormat.from_str.input_path",description:`<strong>input_path</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Where to look for the input data.`,name:"input_path"},{anchor:"transformers.PipelineDataFormat.from_str.column",description:`<strong>column</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The column to read.`,name:"column"},{anchor:"transformers.PipelineDataFormat.from_str.overwrite",description:`<strong>overwrite</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to overwrite the <code>output_path</code>.`,name:"overwrite"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L526",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The proper data format.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/transformers/pr_21171/en/internal/pipelines_utils#transformers.PipelineDataFormat"
>PipelineDataFormat</a></p>
`}}),N=new _({props:{name:"save",anchor:"transformers.PipelineDataFormat.save",parameters:[{name:"data",val:": Union"}],parametersDescription:[{anchor:"transformers.PipelineDataFormat.save.data",description:"<strong>data</strong> (<code>dict</code> or list of <code>dict</code>) &#x2014; The data to store.",name:"data"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L498"}}),R=new _({props:{name:"save_binary",anchor:"transformers.PipelineDataFormat.save_binary",parameters:[{name:"data",val:": Union"}],parametersDescription:[{anchor:"transformers.PipelineDataFormat.save_binary.data",description:"<strong>data</strong> (<code>dict</code> or list of <code>dict</code>) &#x2014; The data to store.",name:"data"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L508",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Path where the data has been saved.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>str</code></p>
`}}),B=new _({props:{name:"class transformers.CsvPipelineDataFormat",anchor:"transformers.CsvPipelineDataFormat",parameters:[{name:"output_path",val:": Optional"},{name:"input_path",val:": Optional"},{name:"column",val:": Optional"},{name:"overwrite",val:" = False"}],parametersDescription:[{anchor:"transformers.CsvPipelineDataFormat.output_path",description:"<strong>output_path</strong> (<code>str</code>) &#x2014; Where to save the outgoing data.",name:"output_path"},{anchor:"transformers.CsvPipelineDataFormat.input_path",description:"<strong>input_path</strong> (<code>str</code>) &#x2014; Where to look for the input data.",name:"input_path"},{anchor:"transformers.CsvPipelineDataFormat.column",description:"<strong>column</strong> (<code>str</code>) &#x2014; The column to read.",name:"column"},{anchor:"transformers.CsvPipelineDataFormat.overwrite",description:`<strong>overwrite</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to overwrite the <code>output_path</code>.`,name:"overwrite"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L562"}}),Z=new _({props:{name:"save",anchor:"transformers.CsvPipelineDataFormat.save",parameters:[{name:"data",val:": List"}],parametersDescription:[{anchor:"transformers.CsvPipelineDataFormat.save.data",description:"<strong>data</strong> (<code>List[dict]</code>) &#x2014; The data to store.",name:"data"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L592"}}),G=new _({props:{name:"class transformers.JsonPipelineDataFormat",anchor:"transformers.JsonPipelineDataFormat",parameters:[{name:"output_path",val:": Optional"},{name:"input_path",val:": Optional"},{name:"column",val:": Optional"},{name:"overwrite",val:" = False"}],parametersDescription:[{anchor:"transformers.JsonPipelineDataFormat.output_path",description:"<strong>output_path</strong> (<code>str</code>) &#x2014; Where to save the outgoing data.",name:"output_path"},{anchor:"transformers.JsonPipelineDataFormat.input_path",description:"<strong>input_path</strong> (<code>str</code>) &#x2014; Where to look for the input data.",name:"input_path"},{anchor:"transformers.JsonPipelineDataFormat.column",description:"<strong>column</strong> (<code>str</code>) &#x2014; The column to read.",name:"column"},{anchor:"transformers.JsonPipelineDataFormat.overwrite",description:`<strong>overwrite</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to overwrite the <code>output_path</code>.`,name:"overwrite"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L606"}}),K=new _({props:{name:"save",anchor:"transformers.JsonPipelineDataFormat.save",parameters:[{name:"data",val:": dict"}],parametersDescription:[{anchor:"transformers.JsonPipelineDataFormat.save.data",description:"<strong>data</strong> (<code>dict</code>) &#x2014; The data to store.",name:"data"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L637"}}),X=new _({props:{name:"class transformers.PipedPipelineDataFormat",anchor:"transformers.PipedPipelineDataFormat",parameters:[{name:"output_path",val:": Optional"},{name:"input_path",val:": Optional"},{name:"column",val:": Optional"},{name:"overwrite",val:": bool = False"}],parametersDescription:[{anchor:"transformers.PipedPipelineDataFormat.output_path",description:"<strong>output_path</strong> (<code>str</code>) &#x2014; Where to save the outgoing data.",name:"output_path"},{anchor:"transformers.PipedPipelineDataFormat.input_path",description:"<strong>input_path</strong> (<code>str</code>) &#x2014; Where to look for the input data.",name:"input_path"},{anchor:"transformers.PipedPipelineDataFormat.column",description:"<strong>column</strong> (<code>str</code>) &#x2014; The column to read.",name:"column"},{anchor:"transformers.PipedPipelineDataFormat.overwrite",description:`<strong>overwrite</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to overwrite the <code>output_path</code>.`,name:"overwrite"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L648"}}),Y=new _({props:{name:"save",anchor:"transformers.PipedPipelineDataFormat.save",parameters:[{name:"data",val:": dict"}],parametersDescription:[{anchor:"transformers.PipedPipelineDataFormat.save.data",description:"<strong>data</strong> (<code>dict</code>) &#x2014; The data to store.",name:"data"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L677"}}),ee=new Ye({props:{title:"Utilities",local:"transformers.pipelines.PipelineException",headingTag:"h2"}}),te=new _({props:{name:"class transformers.pipelines.PipelineException",anchor:"transformers.pipelines.PipelineException",parameters:[{name:"task",val:": str"},{name:"model",val:": str"},{name:"reason",val:": str"}],parametersDescription:[{anchor:"transformers.pipelines.PipelineException.task",description:"<strong>task</strong> (<code>str</code>) &#x2014; The task of the pipeline.",name:"task"},{anchor:"transformers.pipelines.PipelineException.model",description:"<strong>model</strong> (<code>str</code>) &#x2014; The model used by the pipeline.",name:"model"},{anchor:"transformers.pipelines.PipelineException.reason",description:"<strong>reason</strong> (<code>str</code>) &#x2014; The error message to display.",name:"reason"}],source:"https://github.com/huggingface/transformers/blob/vr_21171/src/transformers/pipelines/base.py#L422"}}),re=new Kt({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/en/internal/pipelines_utils.md"}}),{c(){F=s("meta"),ye=a(),we=s("p"),Ce=a(),d(S.$$.fragment),Te=a(),I=s("p"),I.textContent=Ft,Le=a(),V=s("p"),V.textContent=yt,He=a(),d(W.$$.fragment),Ee=a(),y=s("div"),d(q.$$.fragment),et=a(),ae=s("p"),ae.innerHTML=Ct,Me=a(),C=s("div"),d(j.$$.fragment),tt=a(),ne=s("p"),ne.textContent=Tt,ke=a(),P=s("div"),d(J.$$.fragment),rt=a(),oe=s("p"),oe.innerHTML=Lt,at=a(),se=s("p"),se.innerHTML=Ht,Ae=a(),d(U.$$.fragment),Oe=a(),m=s("div"),d(z.$$.fragment),nt=a(),ie=s("p"),ie.textContent=Et,ot=a(),pe=s("ul"),pe.innerHTML=Mt,st=a(),le=s("p"),le.innerHTML=kt,it=a(),L=s("div"),d(Q.$$.fragment),pt=a(),me=s("p"),me.innerHTML=At,lt=a(),H=s("div"),d(N.$$.fragment),mt=a(),de=s("p"),de.innerHTML=Ot,dt=a(),E=s("div"),d(R.$$.fragment),ct=a(),ce=s("p"),ce.textContent=St,Se=a(),D=s("div"),d(B.$$.fragment),ut=a(),ue=s("p"),ue.textContent=It,ft=a(),M=s("div"),d(Z.$$.fragment),ht=a(),fe=s("p"),fe.innerHTML=Vt,Ie=a(),w=s("div"),d(G.$$.fragment),gt=a(),he=s("p"),he.textContent=Wt,vt=a(),k=s("div"),d(K.$$.fragment),$t=a(),ge=s("p"),ge.textContent=qt,Ve=a(),x=s("div"),d(X.$$.fragment),bt=a(),ve=s("p"),ve.textContent=jt,_t=a(),$e=s("p"),$e.textContent=Jt,xt=a(),A=s("div"),d(Y.$$.fragment),Pt=a(),be=s("p"),be.textContent=Ut,We=a(),d(ee.$$.fragment),qe=a(),T=s("div"),d(te.$$.fragment),Dt=a(),_e=s("p"),_e.innerHTML=zt,je=a(),d(re.$$.fragment),Je=a(),Fe=s("p"),this.h()},l(e){const o=Gt("svelte-u9bgzb",document.head);F=i(o,"META",{name:!0,content:!0}),o.forEach(r),ye=n(e),we=i(e,"P",{}),v(we).forEach(r),Ce=n(e),c(S.$$.fragment,e),Te=n(e),I=i(e,"P",{"data-svelte-h":!0}),l(I)!=="svelte-wr9t4b"&&(I.textContent=Ft),Le=n(e),V=i(e,"P",{"data-svelte-h":!0}),l(V)!=="svelte-1ui7w53"&&(V.textContent=yt),He=n(e),c(W.$$.fragment,e),Ee=n(e),y=i(e,"DIV",{class:!0});var ze=v(y);c(q.$$.fragment,ze),et=n(ze),ae=i(ze,"P",{"data-svelte-h":!0}),l(ae)!=="svelte-11x3yz6"&&(ae.innerHTML=Ct),ze.forEach(r),Me=n(e),C=i(e,"DIV",{class:!0});var Qe=v(C);c(j.$$.fragment,Qe),tt=n(Qe),ne=i(Qe,"P",{"data-svelte-h":!0}),l(ne)!=="svelte-1hjf3sf"&&(ne.textContent=Tt),Qe.forEach(r),ke=n(e),P=i(e,"DIV",{class:!0});var xe=v(P);c(J.$$.fragment,xe),rt=n(xe),oe=i(xe,"P",{"data-svelte-h":!0}),l(oe)!=="svelte-12i18ng"&&(oe.innerHTML=Lt),at=n(xe),se=i(xe,"P",{"data-svelte-h":!0}),l(se)!=="svelte-z2nze2"&&(se.innerHTML=Ht),xe.forEach(r),Ae=n(e),c(U.$$.fragment,e),Oe=n(e),m=i(e,"DIV",{class:!0});var b=v(m);c(z.$$.fragment,b),nt=n(b),ie=i(b,"P",{"data-svelte-h":!0}),l(ie)!=="svelte-1mb1edh"&&(ie.textContent=Et),ot=n(b),pe=i(b,"UL",{"data-svelte-h":!0}),l(pe)!=="svelte-1uf4n4e"&&(pe.innerHTML=Mt),st=n(b),le=i(b,"P",{"data-svelte-h":!0}),l(le)!=="svelte-u9lis0"&&(le.innerHTML=kt),it=n(b),L=i(b,"DIV",{class:!0});var Ne=v(L);c(Q.$$.fragment,Ne),pt=n(Ne),me=i(Ne,"P",{"data-svelte-h":!0}),l(me)!=="svelte-axz1vm"&&(me.innerHTML=At),Ne.forEach(r),lt=n(b),H=i(b,"DIV",{class:!0});var Re=v(H);c(N.$$.fragment,Re),mt=n(Re),de=i(Re,"P",{"data-svelte-h":!0}),l(de)!=="svelte-1uhw0hi"&&(de.innerHTML=Ot),Re.forEach(r),dt=n(b),E=i(b,"DIV",{class:!0});var Be=v(E);c(R.$$.fragment,Be),ct=n(Be),ce=i(Be,"P",{"data-svelte-h":!0}),l(ce)!=="svelte-i36752"&&(ce.textContent=St),Be.forEach(r),b.forEach(r),Se=n(e),D=i(e,"DIV",{class:!0});var Pe=v(D);c(B.$$.fragment,Pe),ut=n(Pe),ue=i(Pe,"P",{"data-svelte-h":!0}),l(ue)!=="svelte-jm6p0u"&&(ue.textContent=It),ft=n(Pe),M=i(Pe,"DIV",{class:!0});var Ze=v(M);c(Z.$$.fragment,Ze),ht=n(Ze),fe=i(Ze,"P",{"data-svelte-h":!0}),l(fe)!=="svelte-1uhw0hi"&&(fe.innerHTML=Vt),Ze.forEach(r),Pe.forEach(r),Ie=n(e),w=i(e,"DIV",{class:!0});var De=v(w);c(G.$$.fragment,De),gt=n(De),he=i(De,"P",{"data-svelte-h":!0}),l(he)!=="svelte-jpmp8k"&&(he.textContent=Wt),vt=n(De),k=i(De,"DIV",{class:!0});var Ge=v(k);c(K.$$.fragment,Ge),$t=n(Ge),ge=i(Ge,"P",{"data-svelte-h":!0}),l(ge)!=="svelte-1ly8fsk"&&(ge.textContent=qt),Ge.forEach(r),De.forEach(r),Ve=n(e),x=i(e,"DIV",{class:!0});var O=v(x);c(X.$$.fragment,O),bt=n(O),ve=i(O,"P",{"data-svelte-h":!0}),l(ve)!=="svelte-vxtild"&&(ve.textContent=jt),_t=n(O),$e=i(O,"P",{"data-svelte-h":!0}),l($e)!=="svelte-83moxo"&&($e.textContent=Jt),xt=n(O),A=i(O,"DIV",{class:!0});var Ke=v(A);c(Y.$$.fragment,Ke),Pt=n(Ke),be=i(Ke,"P",{"data-svelte-h":!0}),l(be)!=="svelte-v6konq"&&(be.textContent=Ut),Ke.forEach(r),O.forEach(r),We=n(e),c(ee.$$.fragment,e),qe=n(e),T=i(e,"DIV",{class:!0});var Xe=v(T);c(te.$$.fragment,Xe),Dt=n(Xe),_e=i(Xe,"P",{"data-svelte-h":!0}),l(_e)!=="svelte-fb7nji"&&(_e.innerHTML=zt),Xe.forEach(r),je=n(e),c(re.$$.fragment,e),Je=n(e),Fe=i(e,"P",{}),v(Fe).forEach(r),this.h()},h(){$(F,"name","hf:doc:metadata"),$(F,"content",Yt),$(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),$(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){t(document.head,F),p(e,ye,o),p(e,we,o),p(e,Ce,o),u(S,e,o),p(e,Te,o),p(e,I,o),p(e,Le,o),p(e,V,o),p(e,He,o),u(W,e,o),p(e,Ee,o),p(e,y,o),u(q,y,null),t(y,et),t(y,ae),p(e,Me,o),p(e,C,o),u(j,C,null),t(C,tt),t(C,ne),p(e,ke,o),p(e,P,o),u(J,P,null),t(P,rt),t(P,oe),t(P,at),t(P,se),p(e,Ae,o),u(U,e,o),p(e,Oe,o),p(e,m,o),u(z,m,null),t(m,nt),t(m,ie),t(m,ot),t(m,pe),t(m,st),t(m,le),t(m,it),t(m,L),u(Q,L,null),t(L,pt),t(L,me),t(m,lt),t(m,H),u(N,H,null),t(H,mt),t(H,de),t(m,dt),t(m,E),u(R,E,null),t(E,ct),t(E,ce),p(e,Se,o),p(e,D,o),u(B,D,null),t(D,ut),t(D,ue),t(D,ft),t(D,M),u(Z,M,null),t(M,ht),t(M,fe),p(e,Ie,o),p(e,w,o),u(G,w,null),t(w,gt),t(w,he),t(w,vt),t(w,k),u(K,k,null),t(k,$t),t(k,ge),p(e,Ve,o),p(e,x,o),u(X,x,null),t(x,bt),t(x,ve),t(x,_t),t(x,$e),t(x,xt),t(x,A),u(Y,A,null),t(A,Pt),t(A,be),p(e,We,o),u(ee,e,o),p(e,qe,o),p(e,T,o),u(te,T,null),t(T,Dt),t(T,_e),p(e,je,o),u(re,e,o),p(e,Je,o),p(e,Fe,o),Ue=!0},p:Nt,i(e){Ue||(f(S.$$.fragment,e),f(W.$$.fragment,e),f(q.$$.fragment,e),f(j.$$.fragment,e),f(J.$$.fragment,e),f(U.$$.fragment,e),f(z.$$.fragment,e),f(Q.$$.fragment,e),f(N.$$.fragment,e),f(R.$$.fragment,e),f(B.$$.fragment,e),f(Z.$$.fragment,e),f(G.$$.fragment,e),f(K.$$.fragment,e),f(X.$$.fragment,e),f(Y.$$.fragment,e),f(ee.$$.fragment,e),f(te.$$.fragment,e),f(re.$$.fragment,e),Ue=!0)},o(e){h(S.$$.fragment,e),h(W.$$.fragment,e),h(q.$$.fragment,e),h(j.$$.fragment,e),h(J.$$.fragment,e),h(U.$$.fragment,e),h(z.$$.fragment,e),h(Q.$$.fragment,e),h(N.$$.fragment,e),h(R.$$.fragment,e),h(B.$$.fragment,e),h(Z.$$.fragment,e),h(G.$$.fragment,e),h(K.$$.fragment,e),h(X.$$.fragment,e),h(Y.$$.fragment,e),h(ee.$$.fragment,e),h(te.$$.fragment,e),h(re.$$.fragment,e),Ue=!1},d(e){e&&(r(ye),r(we),r(Ce),r(Te),r(I),r(Le),r(V),r(He),r(Ee),r(y),r(Me),r(C),r(ke),r(P),r(Ae),r(Oe),r(m),r(Se),r(D),r(Ie),r(w),r(Ve),r(x),r(We),r(qe),r(T),r(je),r(Je),r(Fe)),r(F),g(S,e),g(W,e),g(q),g(j),g(J),g(U,e),g(z),g(Q),g(N),g(R),g(B),g(Z),g(G),g(K),g(X),g(Y),g(ee,e),g(te),g(re,e)}}}const Yt='{"title":"Utilities for pipelines","local":"utilities-for-pipelines","sections":[{"title":"Argument handling","local":"transformers.pipelines.ArgumentHandler","sections":[],"depth":2},{"title":"Data format","local":"transformers.PipelineDataFormat","sections":[],"depth":2},{"title":"Utilities","local":"transformers.pipelines.PipelineException","sections":[],"depth":2}],"depth":1}';function er(wt){return Rt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class or extends Bt{constructor(F){super(),Zt(this,F,er,Xt,Qt,{})}}export{or as component};
