import{s as Ve,o as Re,n as Me}from"../chunks/scheduler.56730f09.js";import{S as Xe,i as Ae,g as d,s as m,r as g,A as He,h as b,f as t,c as i,j as Je,u as y,x as _,k as Ue,y as Ee,a,v as j,d as M,t as w,w as v}from"../chunks/index.1f144517.js";import{T as Fe}from"../chunks/Tip.41e845e5.js";import{C as G}from"../chunks/CodeBlock.738eeccb.js";import{F as Ne,M as Ge}from"../chunks/Markdown.c541024b.js";import{H as O,E as Ye}from"../chunks/EditOnGithub.854793f1.js";function ze(J){let l,u='아키텍처는 모델의 골격을 의미하며 체크포인트는 주어진 아키텍처에 대한 가중치입니다. 예를 들어, <a href="https://huggingface.co/google-bert/bert-base-uncased" rel="nofollow">BERT</a>는 아키텍처이고, <code>google-bert/bert-base-uncased</code>는 체크포인트입니다. 모델은 아키텍처 또는 체크포인트를 의미할 수 있는 일반적인 용어입니다.';return{c(){l=d("p"),l.innerHTML=u},l(n){l=b(n,"P",{"data-svelte-h":!0}),_(l)!=="svelte-t6wtei"&&(l.innerHTML=u)},m(n,p){a(n,l,p)},p:Me,d(n){n&&t(l)}}}function Le(J){let l,u=`PyTorch모델의 경우 <code>from_pretrained()</code> 메서드는 내부적으로 피클을 사용하여 안전하지 않은 것으로 알려진 <code>torch.load()</code>를 사용합니다.
일반적으로 신뢰할 수 없는 소스에서 가져왔거나 변조되었을 수 있는 모델은 로드하지 마세요. 허깅 페이스 허브에서 호스팅되는 공개 모델의 경우 이러한 보안 위험이 부분적으로 완화되며, 각 커밋 시 멀웨어를 <a href="https://huggingface.co/docs/hub/security-malware" rel="nofollow">검사합니다</a>. GPG를 사용해 서명된 <a href="https://huggingface.co/docs/hub/security-gpg#signing-commits-with-gpg" rel="nofollow">커밋 검증</a>과 같은 모범사례는 <a href="https://huggingface.co/docs/hub/security" rel="nofollow">문서</a>를 참조하세요.`,n,p,f="텐서플로우와 Flax 체크포인트는 영향을 받지 않으며, <code>from_pretrained</code>메서드에 <code>from_tf</code> 와 <code>from_flax</code> 키워드 가변 인자를 사용하여 이 문제를 우회할 수 있습니다.";return{c(){l=d("p"),l.innerHTML=u,n=m(),p=d("p"),p.innerHTML=f},l(c){l=b(c,"P",{"data-svelte-h":!0}),_(l)!=="svelte-1u3kbez"&&(l.innerHTML=u),n=i(c),p=b(c,"P",{"data-svelte-h":!0}),_(p)!=="svelte-7z7rov"&&(p.innerHTML=f)},m(c,k){a(c,l,k),a(c,n,k),a(c,p,k)},p:Me,d(c){c&&(t(l),t(n),t(p))}}}function Pe(J){let l,u='마지막으로 AutoModelFor클래스를 사용하면 주어진 작업에 대해 미리 학습된 모델을 로드할 수 있습니다 (사용 가능한 작업의 전체 목록은 <a href="model_doc/auto">여기</a>를 참조하세요). 예를 들어, <code>AutoModelForSequenceClassification.from_pretrained()</code>를 사용하여 시퀀스 분류용 모델을 로드할 수 있습니다:',n,p,f,c,k="동일한 체크포인트를 쉽게 재사용하여 다른 작업에 아키텍처를 로드할 수 있습니다:",U,Z,T,h,x,W,o='일반적으로 AutoTokenizer 클래스와 AutoModelFor 클래스를 사용하여 미리 학습된 모델 인스턴스를 로드하는 것이 좋습니다. 이렇게 하면 매번 올바른 아키텍처를 로드할 수 있습니다. 다음 <a href="preprocessing">튜토리얼</a>에서는 새롭게 로드한 토크나이저, 이미지 프로세서, 특징 추출기를 사용하여 미세 튜닝용 데이터 세트를 전처리하는 방법에 대해 알아봅니다.',$;return p=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Nb2RlbEZvclNlcXVlbmNlQ2xhc3NpZmljYXRpb24lMEElMEFtb2RlbCUyMCUzRCUyMEF1dG9Nb2RlbEZvclNlcXVlbmNlQ2xhc3NpZmljYXRpb24uZnJvbV9wcmV0cmFpbmVkKCUyMmRpc3RpbGJlcnQlMkZkaXN0aWxiZXJ0LWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;distilbert/distilbert-base-uncased&quot;</span>)`,wrap:!1}}),Z=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Nb2RlbEZvclRva2VuQ2xhc3NpZmljYXRpb24lMEElMEFtb2RlbCUyMCUzRCUyMEF1dG9Nb2RlbEZvclRva2VuQ2xhc3NpZmljYXRpb24uZnJvbV9wcmV0cmFpbmVkKCUyMmRpc3RpbGJlcnQlMkZkaXN0aWxiZXJ0LWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForTokenClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForTokenClassification.from_pretrained(<span class="hljs-string">&quot;distilbert/distilbert-base-uncased&quot;</span>)`,wrap:!1}}),h=new Fe({props:{warning:!0,$$slots:{default:[Le]},$$scope:{ctx:J}}}),{c(){l=d("p"),l.innerHTML=u,n=m(),g(p.$$.fragment),f=m(),c=d("p"),c.textContent=k,U=m(),g(Z.$$.fragment),T=m(),g(h.$$.fragment),x=m(),W=d("p"),W.innerHTML=o},l(r){l=b(r,"P",{"data-svelte-h":!0}),_(l)!=="svelte-18uszv6"&&(l.innerHTML=u),n=i(r),y(p.$$.fragment,r),f=i(r),c=b(r,"P",{"data-svelte-h":!0}),_(c)!=="svelte-7ro1yz"&&(c.textContent=k),U=i(r),y(Z.$$.fragment,r),T=i(r),y(h.$$.fragment,r),x=i(r),W=b(r,"P",{"data-svelte-h":!0}),_(W)!=="svelte-4umuej"&&(W.innerHTML=o)},m(r,C){a(r,l,C),a(r,n,C),j(p,r,C),a(r,f,C),a(r,c,C),a(r,U,C),j(Z,r,C),a(r,T,C),j(h,r,C),a(r,x,C),a(r,W,C),$=!0},p(r,C){const F={};C&2&&(F.$$scope={dirty:C,ctx:r}),h.$set(F)},i(r){$||(M(p.$$.fragment,r),M(Z.$$.fragment,r),M(h.$$.fragment,r),$=!0)},o(r){w(p.$$.fragment,r),w(Z.$$.fragment,r),w(h.$$.fragment,r),$=!1},d(r){r&&(t(l),t(n),t(f),t(c),t(U),t(T),t(x),t(W)),v(p,r),v(Z,r),v(h,r)}}}function qe(J){let l,u;return l=new Ge({props:{$$slots:{default:[Pe]},$$scope:{ctx:J}}}),{c(){g(l.$$.fragment)},l(n){y(l.$$.fragment,n)},m(n,p){j(l,n,p),u=!0},p(n,p){const f={};p&2&&(f.$$scope={dirty:p,ctx:n}),l.$set(f)},i(n){u||(M(l.$$.fragment,n),u=!0)},o(n){w(l.$$.fragment,n),u=!1},d(n){v(l,n)}}}function Ie(J){let l,u='마지막으로 <code>TFAutoModelFor</code> 클래스를 사용하면 주어진 작업에 대해 사전 훈련된 모델을 로드할 수 있습니다. (사용 가능한 작업의 전체 목록은 <a href="model_doc/auto">여기</a>를 참조하세요. 예를 들어, <code>TFAutoModelForSequenceClassification.from_pretrained()</code>로 시퀀스 분류를 위한 모델을 로드합니다:',n,p,f,c,k="쉽게 동일한 체크포인트를 재사용하여 다른 작업에 아키텍처를 로드할 수 있습니다:",U,Z,T,h,x='일반적으로, <code>AutoTokenizer</code>클래스와 <code>TFAutoModelFor</code> 클래스를 사용하여 미리 학습된 모델 인스턴스를 로드하는 것이 좋습니다. 이렇게 하면 매번 올바른 아키텍처를 로드할 수 있습니다. 다음 <a href="preprocessing">튜토리얼</a>에서는 새롭게 로드한 토크나이저, 이미지 프로세서, 특징 추출기를 사용하여 미세 튜닝용 데이터 세트를 전처리하는 방법에 대해 알아봅니다.',W;return p=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMFRGQXV0b01vZGVsRm9yU2VxdWVuY2VDbGFzc2lmaWNhdGlvbiUwQSUwQW1vZGVsJTIwJTNEJTIwVEZBdXRvTW9kZWxGb3JTZXF1ZW5jZUNsYXNzaWZpY2F0aW9uLmZyb21fcHJldHJhaW5lZCglMjJkaXN0aWxiZXJ0JTJGZGlzdGlsYmVydC1iYXNlLXVuY2FzZWQlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;distilbert/distilbert-base-uncased&quot;</span>)`,wrap:!1}}),Z=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMFRGQXV0b01vZGVsRm9yVG9rZW5DbGFzc2lmaWNhdGlvbiUwQSUwQW1vZGVsJTIwJTNEJTIwVEZBdXRvTW9kZWxGb3JUb2tlbkNsYXNzaWZpY2F0aW9uLmZyb21fcHJldHJhaW5lZCglMjJkaXN0aWxiZXJ0JTJGZGlzdGlsYmVydC1iYXNlLXVuY2FzZWQlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForTokenClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForTokenClassification.from_pretrained(<span class="hljs-string">&quot;distilbert/distilbert-base-uncased&quot;</span>)`,wrap:!1}}),{c(){l=d("p"),l.innerHTML=u,n=m(),g(p.$$.fragment),f=m(),c=d("p"),c.textContent=k,U=m(),g(Z.$$.fragment),T=m(),h=d("p"),h.innerHTML=x},l(o){l=b(o,"P",{"data-svelte-h":!0}),_(l)!=="svelte-xsgejq"&&(l.innerHTML=u),n=i(o),y(p.$$.fragment,o),f=i(o),c=b(o,"P",{"data-svelte-h":!0}),_(c)!=="svelte-1ilzt8b"&&(c.textContent=k),U=i(o),y(Z.$$.fragment,o),T=i(o),h=b(o,"P",{"data-svelte-h":!0}),_(h)!=="svelte-1w046dp"&&(h.innerHTML=x)},m(o,$){a(o,l,$),a(o,n,$),j(p,o,$),a(o,f,$),a(o,c,$),a(o,U,$),j(Z,o,$),a(o,T,$),a(o,h,$),W=!0},p:Me,i(o){W||(M(p.$$.fragment,o),M(Z.$$.fragment,o),W=!0)},o(o){w(p.$$.fragment,o),w(Z.$$.fragment,o),W=!1},d(o){o&&(t(l),t(n),t(f),t(c),t(U),t(T),t(h)),v(p,o),v(Z,o)}}}function Qe(J){let l,u;return l=new Ge({props:{$$slots:{default:[Ie]},$$scope:{ctx:J}}}),{c(){g(l.$$.fragment)},l(n){y(l.$$.fragment,n)},m(n,p){j(l,n,p),u=!0},p(n,p){const f={};p&2&&(f.$$scope={dirty:p,ctx:n}),l.$set(f)},i(n){u||(M(l.$$.fragment,n),u=!0)},o(n){w(l.$$.fragment,n),u=!1},d(n){v(l,n)}}}function Be(J){let l,u,n,p,f,c,k,U=`트랜스포머 아키텍처가 매우 다양하기 때문에 체크포인트에 맞는 아키텍처를 생성하는 것이 어려울 수 있습니다. 라이브러리를 쉽고 간단하며 유연하게 사용하기 위한 Transformer 핵심 철학의 일환으로, <code>AutoClass</code>는 주어진 체크포인트에서 올바른 아키텍처를 자동으로 추론하여 로드합니다. <code>from_pretrained()</code> 메서드를 사용하면 모든 아키텍처에 대해 사전 학습된 모델을 빠르게 로드할 수 있으므로 모델을 처음부터 학습하는 데 시간과 리소스를 투입할 필요가 없습니다.
체크포인트에 구애받지 않는 코드를 생성한다는 것은 코드가 한 체크포인트에서 작동하면 아키텍처가 다르더라도 다른 체크포인트(유사한 작업에 대해 학습된 경우)에서도 작동한다는 것을 의미합니다.`,Z,T,h,x,W="이 튜토리얼에서는 다음을 학습합니다:",o,$,r="<li>사전 학습된 토크나이저 로드하기.</li> <li>사전 학습된 이미지 프로세서 로드하기.</li> <li>사전 학습된 특징 추출기 로드하기.</li> <li>사전 훈련된 프로세서 로드하기.</li> <li>사전 학습된 모델 로드하기.</li>",C,F,te,R,we=`거의 모든 NLP 작업은 토크나이저로 시작됩니다. 토크나이저는 사용자의 입력을 모델에서 처리할 수 있는 형식으로 변환합니다.
<code>AutoTokenizer.from_pretrained()</code>로 토크나이저를 로드합니다:`,se,X,le,A,ve="그리고 아래와 같이 입력을 토큰화합니다:",ae,H,ne,E,re,N,Ze="비전 작업의 경우 이미지 프로세서가 이미지를 올바른 입력 형식으로 처리합니다.",pe,Y,oe,z,me,L,Ce="오디오 작업의 경우 특징 추출기가 오디오 신호를 올바른 입력 형식으로 처리합니다.",ie,P,_e="<code>AutoFeatureExtractor.from_pretrained()</code>로 특징 추출기를 로드합니다:",ce,q,ue,I,fe,Q,Te="멀티모달 작업에는 두 가지 유형의 전처리 도구를 결합한 프로세서가 필요합니다. 예를 들어 LayoutLMV2 모델에는 이미지를 처리하는 이미지 프로세서와 텍스트를 처리하는 토크나이저가 필요하며, 프로세서는 이 두 가지를 결합합니다.",$e,B,ke="<code>AutoProcessor.from_pretrained()</code>로 프로세서를 로드합니다:",de,S,be,K,he,V,ge,D,ye,ee,je;return f=new O({props:{title:"AutoClass로 사전 학습된 인스턴스 로드",local:"load-pretrained-instances-with-an-autoclass",headingTag:"h1"}}),T=new Fe({props:{$$slots:{default:[ze]},$$scope:{ctx:J}}}),F=new O({props:{title:"AutoTokenizer",local:"autotokenizer",headingTag:"h2"}}),X=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Ub2tlbml6ZXIlMEElMEF0b2tlbml6ZXIlMjAlM0QlMjBBdXRvVG9rZW5pemVyLmZyb21fcHJldHJhaW5lZCglMjJnb29nbGUtYmVydCUyRmJlcnQtYmFzZS11bmNhc2VkJTIyKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;google-bert/bert-base-uncased&quot;</span>)`,wrap:!1}}),H=new G({props:{code:"c2VxdWVuY2UlMjAlM0QlMjAlMjJJbiUyMGElMjBob2xlJTIwaW4lMjB0aGUlMjBncm91bmQlMjB0aGVyZSUyMGxpdmVkJTIwYSUyMGhvYmJpdC4lMjIlMEFwcmludCh0b2tlbml6ZXIoc2VxdWVuY2UpKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>sequence = <span class="hljs-string">&quot;In a hole in the ground there lived a hobbit.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer(sequence))
{<span class="hljs-string">&#x27;input_ids&#x27;</span>: [<span class="hljs-number">101</span>, <span class="hljs-number">1999</span>, <span class="hljs-number">1037</span>, <span class="hljs-number">4920</span>, <span class="hljs-number">1999</span>, <span class="hljs-number">1996</span>, <span class="hljs-number">2598</span>, <span class="hljs-number">2045</span>, <span class="hljs-number">2973</span>, <span class="hljs-number">1037</span>, <span class="hljs-number">7570</span>, <span class="hljs-number">10322</span>, <span class="hljs-number">4183</span>, <span class="hljs-number">1012</span>, <span class="hljs-number">102</span>], 
 <span class="hljs-string">&#x27;token_type_ids&#x27;</span>: [<span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>], 
 <span class="hljs-string">&#x27;attention_mask&#x27;</span>: [<span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>]}`,wrap:!1}}),E=new O({props:{title:"AutoImageProcessor",local:"autoimageprocessor",headingTag:"h2"}}),Y=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9JbWFnZVByb2Nlc3NvciUwQSUwQWltYWdlX3Byb2Nlc3NvciUyMCUzRCUyMEF1dG9JbWFnZVByb2Nlc3Nvci5mcm9tX3ByZXRyYWluZWQoJTIyZ29vZ2xlJTJGdml0LWJhc2UtcGF0Y2gxNi0yMjQlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;google/vit-base-patch16-224&quot;</span>)`,wrap:!1}}),z=new O({props:{title:"AutoFeatureExtractor",local:"autofeatureextractor",headingTag:"h2"}}),q=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9GZWF0dXJlRXh0cmFjdG9yJTBBJTBBZmVhdHVyZV9leHRyYWN0b3IlMjAlM0QlMjBBdXRvRmVhdHVyZUV4dHJhY3Rvci5mcm9tX3ByZXRyYWluZWQoJTBBJTIwJTIwJTIwJTIwJTIyZWhjYWxhYnJlcyUyRndhdjJ2ZWMyLWxnLXhsc3ItZW4tc3BlZWNoLWVtb3Rpb24tcmVjb2duaXRpb24lMjIlMEEp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;ehcalabres/wav2vec2-lg-xlsr-en-speech-emotion-recognition&quot;</span>
<span class="hljs-meta">... </span>)`,wrap:!1}}),I=new O({props:{title:"AutoProcessor",local:"autoprocessor",headingTag:"h2"}}),S=new G({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Qcm9jZXNzb3IlMEElMEFwcm9jZXNzb3IlMjAlM0QlMjBBdXRvUHJvY2Vzc29yLmZyb21fcHJldHJhaW5lZCglMjJtaWNyb3NvZnQlMkZsYXlvdXRsbXYyLWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/layoutlmv2-base-uncased&quot;</span>)`,wrap:!1}}),K=new O({props:{title:"AutoModel",local:"automodel",headingTag:"h2"}}),V=new Ne({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[Qe],pytorch:[qe]},$$scope:{ctx:J}}}),D=new Ye({props:{source:"https://github.com/huggingface/transformers/blob/main/docs/source/ko/autoclass_tutorial.md"}}),{c(){l=d("meta"),u=m(),n=d("p"),p=m(),g(f.$$.fragment),c=m(),k=d("p"),k.innerHTML=U,Z=m(),g(T.$$.fragment),h=m(),x=d("p"),x.textContent=W,o=m(),$=d("ul"),$.innerHTML=r,C=m(),g(F.$$.fragment),te=m(),R=d("p"),R.innerHTML=we,se=m(),g(X.$$.fragment),le=m(),A=d("p"),A.textContent=ve,ae=m(),g(H.$$.fragment),ne=m(),g(E.$$.fragment),re=m(),N=d("p"),N.textContent=Ze,pe=m(),g(Y.$$.fragment),oe=m(),g(z.$$.fragment),me=m(),L=d("p"),L.textContent=Ce,ie=m(),P=d("p"),P.innerHTML=_e,ce=m(),g(q.$$.fragment),ue=m(),g(I.$$.fragment),fe=m(),Q=d("p"),Q.textContent=Te,$e=m(),B=d("p"),B.innerHTML=ke,de=m(),g(S.$$.fragment),be=m(),g(K.$$.fragment),he=m(),g(V.$$.fragment),ge=m(),g(D.$$.fragment),ye=m(),ee=d("p"),this.h()},l(e){const s=He("svelte-u9bgzb",document.head);l=b(s,"META",{name:!0,content:!0}),s.forEach(t),u=i(e),n=b(e,"P",{}),Je(n).forEach(t),p=i(e),y(f.$$.fragment,e),c=i(e),k=b(e,"P",{"data-svelte-h":!0}),_(k)!=="svelte-77k0i5"&&(k.innerHTML=U),Z=i(e),y(T.$$.fragment,e),h=i(e),x=b(e,"P",{"data-svelte-h":!0}),_(x)!=="svelte-qqdsnz"&&(x.textContent=W),o=i(e),$=b(e,"UL",{"data-svelte-h":!0}),_($)!=="svelte-fay6vf"&&($.innerHTML=r),C=i(e),y(F.$$.fragment,e),te=i(e),R=b(e,"P",{"data-svelte-h":!0}),_(R)!=="svelte-7pofg0"&&(R.innerHTML=we),se=i(e),y(X.$$.fragment,e),le=i(e),A=b(e,"P",{"data-svelte-h":!0}),_(A)!=="svelte-2tta70"&&(A.textContent=ve),ae=i(e),y(H.$$.fragment,e),ne=i(e),y(E.$$.fragment,e),re=i(e),N=b(e,"P",{"data-svelte-h":!0}),_(N)!=="svelte-34kd90"&&(N.textContent=Ze),pe=i(e),y(Y.$$.fragment,e),oe=i(e),y(z.$$.fragment,e),me=i(e),L=b(e,"P",{"data-svelte-h":!0}),_(L)!=="svelte-uavi10"&&(L.textContent=Ce),ie=i(e),P=b(e,"P",{"data-svelte-h":!0}),_(P)!=="svelte-1kkigej"&&(P.innerHTML=_e),ce=i(e),y(q.$$.fragment,e),ue=i(e),y(I.$$.fragment,e),fe=i(e),Q=b(e,"P",{"data-svelte-h":!0}),_(Q)!=="svelte-55zai9"&&(Q.textContent=Te),$e=i(e),B=b(e,"P",{"data-svelte-h":!0}),_(B)!=="svelte-r7eo2t"&&(B.innerHTML=ke),de=i(e),y(S.$$.fragment,e),be=i(e),y(K.$$.fragment,e),he=i(e),y(V.$$.fragment,e),ge=i(e),y(D.$$.fragment,e),ye=i(e),ee=b(e,"P",{}),Je(ee).forEach(t),this.h()},h(){Ue(l,"name","hf:doc:metadata"),Ue(l,"content",Se)},m(e,s){Ee(document.head,l),a(e,u,s),a(e,n,s),a(e,p,s),j(f,e,s),a(e,c,s),a(e,k,s),a(e,Z,s),j(T,e,s),a(e,h,s),a(e,x,s),a(e,o,s),a(e,$,s),a(e,C,s),j(F,e,s),a(e,te,s),a(e,R,s),a(e,se,s),j(X,e,s),a(e,le,s),a(e,A,s),a(e,ae,s),j(H,e,s),a(e,ne,s),j(E,e,s),a(e,re,s),a(e,N,s),a(e,pe,s),j(Y,e,s),a(e,oe,s),j(z,e,s),a(e,me,s),a(e,L,s),a(e,ie,s),a(e,P,s),a(e,ce,s),j(q,e,s),a(e,ue,s),j(I,e,s),a(e,fe,s),a(e,Q,s),a(e,$e,s),a(e,B,s),a(e,de,s),j(S,e,s),a(e,be,s),j(K,e,s),a(e,he,s),j(V,e,s),a(e,ge,s),j(D,e,s),a(e,ye,s),a(e,ee,s),je=!0},p(e,[s]){const xe={};s&2&&(xe.$$scope={dirty:s,ctx:e}),T.$set(xe);const We={};s&2&&(We.$$scope={dirty:s,ctx:e}),V.$set(We)},i(e){je||(M(f.$$.fragment,e),M(T.$$.fragment,e),M(F.$$.fragment,e),M(X.$$.fragment,e),M(H.$$.fragment,e),M(E.$$.fragment,e),M(Y.$$.fragment,e),M(z.$$.fragment,e),M(q.$$.fragment,e),M(I.$$.fragment,e),M(S.$$.fragment,e),M(K.$$.fragment,e),M(V.$$.fragment,e),M(D.$$.fragment,e),je=!0)},o(e){w(f.$$.fragment,e),w(T.$$.fragment,e),w(F.$$.fragment,e),w(X.$$.fragment,e),w(H.$$.fragment,e),w(E.$$.fragment,e),w(Y.$$.fragment,e),w(z.$$.fragment,e),w(q.$$.fragment,e),w(I.$$.fragment,e),w(S.$$.fragment,e),w(K.$$.fragment,e),w(V.$$.fragment,e),w(D.$$.fragment,e),je=!1},d(e){e&&(t(u),t(n),t(p),t(c),t(k),t(Z),t(h),t(x),t(o),t($),t(C),t(te),t(R),t(se),t(le),t(A),t(ae),t(ne),t(re),t(N),t(pe),t(oe),t(me),t(L),t(ie),t(P),t(ce),t(ue),t(fe),t(Q),t($e),t(B),t(de),t(be),t(he),t(ge),t(ye),t(ee)),t(l),v(f,e),v(T,e),v(F,e),v(X,e),v(H,e),v(E,e),v(Y,e),v(z,e),v(q,e),v(I,e),v(S,e),v(K,e),v(V,e),v(D,e)}}}const Se='{"title":"AutoClass로 사전 학습된 인스턴스 로드","local":"load-pretrained-instances-with-an-autoclass","sections":[{"title":"AutoTokenizer","local":"autotokenizer","sections":[],"depth":2},{"title":"AutoImageProcessor","local":"autoimageprocessor","sections":[],"depth":2},{"title":"AutoFeatureExtractor","local":"autofeatureextractor","sections":[],"depth":2},{"title":"AutoProcessor","local":"autoprocessor","sections":[],"depth":2},{"title":"AutoModel","local":"automodel","sections":[],"depth":2}],"depth":1}';function Ke(J){return Re(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class at extends Xe{constructor(l){super(),Ae(this,l,Ke,Be,Ve,{})}}export{at as component};
